//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UForPract2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForPrac1 *ForPrac1;
//---------------------------------------------------------------------------
__fastcall TForPrac1::TForPrac1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForPrac1::FormCreate(TObject *Sender)
{
        NombArchOri = NombArchCif = "";
        init(cifrado);
        init(clave);
        modificado = true;
}
//---------------------------------------------------------------------------

void __fastcall TForPrac1::FormDestroy(TObject *Sender)
{
        free(cifrado);
        free(clave);
}
//---------------------------------------------------------------------------

void __fastcall TForPrac1::MemOrigChange(TObject *Sender)
{
        modificado = true;
        if(NombArchOri == "")
        {
        }
        else
        {
                Guardar1->Enabled = true;
        }
}
//---------------------------------------------------------------------------

void __fastcall TForPrac1::BotSalirClick(TObject *Sender)
{
        if(MessageDlg("Seguro?", mtConfirmation, TMsgDlgButtons() << mbYes << mbNo,0) == mrYes)
        {
                Close();
        }
}
//---------------------------------------------------------------------------

void __fastcall TForPrac1::Nuevo1Click(TObject *Sender)
{
        NombArchOri = NombArchCif = "";
        EdiArch->Text = "";
        MemOrig->Clear();
        MemCifr->Clear();
        LabPass->Caption = "--------------------------------";
        Guardar1->Enabled = false;
        modificado = true;
}
//---------------------------------------------------------------------------

void __fastcall TForPrac1::Texto1Click(TObject *Sender)
{
        if(OpenDialog1->Execute())
        {
                NombArchOri = OpenDialog1->FileName;
                MemOrig->Lines->LoadFromFile(NombArchOri);
                EdiArch->Text = NombArchOri;
                Guardar1->Enabled = true;
                modificado = false;
                LabPass->Caption = "--------------------------------";
        }
}
//---------------------------------------------------------------------------

void __fastcall TForPrac1::Cifrado1Click(TObject *Sender)
{
        if(OpenDialog1->Execute())
        {
                NombArchCif = OpenDialog1->FileName;
                MemCifr->Lines->LoadFromFile(NombArchCif);
                EdiArch->Text = NombArchCif;
                Guardar1->Enabled = true;
                LabPass->Caption = "--------------------------------";
        }
}
//---------------------------------------------------------------------------

void __fastcall TForPrac1::GuardarTexto1Click(TObject *Sender)
{
        if(SaveDialog1->Execute())
        {
                NombArchOri = SaveDialog1->FileName;
                Guardar1Click(Sender);
        }
}
//---------------------------------------------------------------------------

void __fastcall TForPrac1::Guardar1Click(TObject *Sender)
{
        if(NombArchOri != "")
        {
                MemOrig->Lines->SaveToFile(NombArchOri);
                EdiArch->Text = NombArchOri;
                modificado = false;
                Guardar1->Enabled = false;
        }
}
//---------------------------------------------------------------------------

void __fastcall TForPrac1::BotCifrarClick(TObject *Sender)
{
        if((NombArchOri == "") || modificado)
        {
                ShowMessage("Es necesario guardar el archivo para codificarlo.");
        }
        else
        {
                AnsiString clav = "";
                if(InputQuery("Clave", "Introduzca la clave", clav))
                {
                        toCadenaExt(clav.c_str(), clave);
                        if(setClave(cifrado, clave))
                        {
                                ifstream strEnt;
                                ofstream strSal;
                                NombArchCif = NombArchOri + ".rc4";
                                setOperCfr(cifrado, cifrar);
                                strEnt.open(NombArchOri.c_str());
                                strSal.open(NombArchCif.c_str());
                                LabPass->Caption = clav;
                                if(cfrStream(&strEnt, &strSal))
                                {
                                        MemCifr->Lines->LoadFromFile(NombArchCif);
                                }
                        }
                        else
                        {
                                ShowMessage("Debe escribir una clave valida (Long mayor a 0)");
                        }
                }
        }
}
//---------------------------------------------------------------------------

void __fastcall TForPrac1::BotDescifrarClick(TObject *Sender)
{
        if(NombArchCif == "")
        {
                ShowMessage("Es necesario tener un archivo abierto para decodificarlo.");
        }
        else
        {
                AnsiString clav = "";
                if(InputQuery("Clave", "Introduzca la clave", clav))
                {
                        toCadenaExt(clav.c_str(), clave);
                        if(setClave(cifrado, clave))
                        {
                                ifstream strEnt;
                                ofstream strSal;
                                LabPass->Caption = clav;
                                NombArchOri = NombArchCif;
                                NombArchOri = NombArchOri.SetLength(NombArchOri.Length() - 4);
                                setOperCfr(cifrado, descifrar);
                                strEnt.open(NombArchCif.c_str());
                                strSal.open(NombArchOri.c_str());
                                if(cfrStream(&strEnt, &strSal))
                                {
                                        MemOrig->Lines->LoadFromFile(NombArchOri);
                                }
                        }
                        else
                        {
                                ShowMessage("Debe escribir una clave valida (Long mayor a 0)");
                        }
                }
        }
}
//---------------------------------------------------------------------------

bool TForPrac1::cfrStream(ifstream *strEnt, ofstream *strSal)
{
        CadenaExt ent, sal;
        if(strEnt->good() && strSal->good())
        {
                init(ent);
                init(sal);
                while(getLine(ent, *strEnt))
                {
                        exeOperCfr(cifrado, ent, sal);
                        putLine(sal, *strSal);
                }
                strEnt->close();
                strSal->close();
                free(ent);
                free(sal);
                return true;
        }
        else return false;
}

