//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UCadenaExt.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

void CadenaExt::init(tSize S)
{
        if(S == 0)
        {
                vector = NULL;
        }
        else
        {
                vector = new CharExt[S];
        }
        cont = 0;
        maxLC = S;
}

void CadenaExt::free()
{
        delete[] vector;
        vector = NULL;
        cont = 0;
        maxLC = 0;
}

void CadenaExt::clear()
{
        cont = 0;
}

CadenaExt& CadenaExt::operator =(const CadenaExt & Cad)
{
        if(&vector != &Cad.vector)
        {
                clear();
                resize(Cad.size());
                for(tSize i = 0; i < Cad.size(); i++)
                {
                        push_back(Cad.at(i));
                }
        }
        return *this;
}

CadenaExt& CadenaExt::operator =(const char cstr[])
{
        clear();
        tSize i = 0;
        while(cstr[i] != '\0')
        {
                push_back(cstr[i]);
                i++;
        }
        resize(size());
        return *this;
}

void CadenaExt::resize(tSize S)
{
        if(S <= 0)
        {
                free();
        }
        else
        {
                if(vector == NULL)
                {
                        init(S);
                }
                else
                {
                        if(max_size() != S)
                        {
                                CharExt* aux;
                                aux = new CharExt[S];
                                for(tSize i = 0; (i < S) && (i < size()); i++)
                                {
                                        aux[i] = vector[i];
                                }
                                delete[] vector;
                                vector = aux;
                                maxLC = S;
                                if(S < size())
                                {
                                        cont = S;
                                }
                        }
                }
        }
}

bool CadenaExt::push_back(CharExt C)
{
        if(size() >= 0)
        {
                resize(320);
        }
        if(size() == max_size())
        {
                resize(max_size() * 2);
        }
        vector[cont] = C;
        cont++;
        return true;
}

bool CadenaExt::pop_back()
{
        if(size() > 0)
        {
                cont--;
                vector[cont] = '\0';
                return true;
        }
        else return false;
}

CharExt CadenaExt::at(tSize N) const
{
        if(inrange(N))
        {
                return vector[N];
        }
        else throw exception();
}

CharExt& CadenaExt::at(tSize N)
{
        if(inrange(N))
        {
                return vector[N];
        }
        else throw exception();
}

bool CadenaExt::replace(tSize N, CharExt C)
{
        at(N) = C;
        return true;
}

bool CadenaExt::swap(tSize N, tSize K)
{
        if(inrange(N) && inrange(K))
        {
                CharExt ch = at(N);
                replace(N, at(K));
                replace(K, ch);
                return true;
        }
        else return false;
}

bool get(CadenaExt & Cad, istream & Ent) // lee hasta blanco, salto de línea o final de stream
{
        char ch;
        Cad.clear();
        while(Ent.get(ch) && (ch != '\n')  && (ch != ' ') && Ent.good())
        {
                Cad.push_back(CharExt(ch));
        }
        Cad.resize(Cad.size());

	return ((Cad.size() > 0) || Ent.good());
}

bool getLine(CadenaExt& Cad, istream& Ent)
{
        char ch;
        Cad.clear();
        while(Ent.get(ch) && (ch != '\n')  && Ent.good())
        {
                Cad.push_back(CharExt(ch));
        }
        Cad.resize(Cad.size());

        return ((Cad.size() > 0) || Ent.good());
}

bool put(const CadenaExt& Cad, ostream& Sal)
{
        tSize i = 0;
        while((i < Cad.size()) && Sal.put(Cad.at(i)))
        {
                i++;
        }
        return Sal;
}


