//---------------------------------------------------------------------------

#ifndef UCadenaExtH
#define UCadenaExtH

#include "limits.h"
#include <iostream>
using namespace std;
//---------------------------------------------------------------------------

typedef unsigned char CharExt;
typedef unsigned int tSize;

const tSize LonChEx = (CHAR_MAX+1)*2; // 256=128*2 , del 0 al 255
//const tSize MaxLC = 320; // Constante para el tamao mximo de una Cadena

class CadenaExt
{
private:
        tSize cont;
        tSize maxLC;
        CharExt* vector;

        void init(tSize S=320);
        void free();

public:
        CadenaExt(tSize S=320) {init(S);};
        CadenaExt(const CadenaExt& Cad) {*this = Cad;};
        ~CadenaExt() {free();};
        void clear();
        CadenaExt& operator =(const CadenaExt & Cad);
        CadenaExt& operator =(const char cstr[]);
        void resize(tSize S);
        tSize size() const {return cont;};
        tSize max_size() const {return maxLC;};
        bool inrange(tSize N) const {return (N < size());};
        bool push_back(CharExt C);
        CadenaExt& operator +( CharExt C) {push_back(C); return *this; }
        bool pop_back();
        CharExt at(tSize N) const;
        CharExt& at(tSize N);
        CharExt operator[] (tSize K) const {return at(K);}
        CharExt& operator[] (tSize K) {return at(K);}
        bool replace(tSize N, const CharExt C);
        bool swap(tSize N, tSize K);
        friend bool getLine(CadenaExt & Cad, istream & Ent);
        friend bool put(const CadenaExt & Cad, ostream & Sal);
        friend bool putLine(const CadenaExt & Cad, ostream & Sal);
        friend bool get (CadenaExt & Cad, istream & Ent);
};

// funciones
bool get (CadenaExt & Cad, istream & Ent); // lee hasta blanco, salto de lnea o final de stream
bool getLine(CadenaExt & Cad, istream & Ent);
bool put(const CadenaExt & Cad, ostream & Sal);
inline bool putLine(const CadenaExt& Cad, ostream& Sal) {put(Cad, Sal); Sal << endl; return Sal;};
inline ostream& operator <<(ostream & sal, const CadenaExt& cad) {put(cad,sal);return sal;};
inline istream& operator >>(istream & ent, CadenaExt & cad){get(cad,ent); return ent;};

#endif
