//---------------------------------------------------------------------------

#ifndef UCifraRC4H
#define UCifraRC4H

#include <UCadenaExt.h>
//---------------------------------------------------------------------------

enum opeCfr {cifrar, descifrar};

const tSize LonCtrl = 32; // char de control: del 0 al 31
const tSize LonAlfa = LonChEx - LonCtrl; // 256 32=224, del 0 al 223

class CifraRC4
{
typedef CharExt (CifraRC4::*FunCfr)(CharExt, CharExt);

private:
        tSize cA, cB;
        CadenaExt abc;
        CadenaExt clave;
        FunCfr funCfr;
        bool init();
        void free();
        void inicial(); // alfabeto inicial de partida para generar la semilla
        void siguiente(); // siguiente alfabeto para la generación de la secuencia
        CharExt genABC(); // siguiente de la secuencia
        CharExt addCfr(CharExt a, CharExt b);
        CharExt difCfr(CharExt a, CharExt b);

public:
        CifraRC4() {init();};
        ~CifraRC4() {free();};
        bool setClave(const CadenaExt& clave); // semilla
        void setOperCfr(opeCfr op);
        void exeOperCfr(const CadenaExt& Ent, CadenaExt& Sal);
};

#endif
